﻿namespace TabsStudioSingleRow
{
    class HiddenStateSaver
    {
        public HiddenStateSaver()
        {
            hiddenWindows = new System.Collections.Generic.List<EnvDTE.Window>();
            saving = true;

            SingleRow.GetEngine().TabExtensionCreated += OnExtensionCreated;
            SingleRow.GetEngine().TabExtensionDestroyed += OnExtensionDestroyed;
        }

        public void Close()
        {
            SingleRow.GetEngine().TabExtensionCreated -= OnExtensionCreated;
            SingleRow.GetEngine().TabExtensionDestroyed -= OnExtensionDestroyed;
        }

        public bool IsHidden(EnvDTE.Window w)
        {
            return hiddenWindows.Contains(w);
        }

        private void OnExtensionCreated(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            saving = false;
        }

        private void OnExtensionDestroyed(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            if (!saving)
            {
                hiddenWindows.Clear();
                saving = true;
            }

            if (Properties.GetIsTabHidden(e.Tab.TabItem))
                hiddenWindows.Add(e.TabExtension.Window);
        }

        private System.Collections.Generic.List<EnvDTE.Window> hiddenWindows;
        private bool saving;
    }
}
