﻿namespace TabsStudioSingleRow
{
    public class Properties
    {
        public static readonly System.Windows.DependencyProperty IsTabHiddenProperty;
        public static readonly System.Windows.DependencyProperty IsHiddenTabsProperty;

        static Properties()
        {
            IsTabHiddenProperty = System.Windows.DependencyProperty.RegisterAttached(
                "IsTabHidden", typeof(bool), typeof(Properties));
            IsHiddenTabsProperty = System.Windows.DependencyProperty.RegisterAttached(
                "IsHiddenTabs", typeof(bool), typeof(Properties));
        }

        public static void SetIsTabHidden(System.Windows.UIElement element, bool value)
        {
            element.SetValue(IsTabHiddenProperty, value);
        }

        public static bool GetIsTabHidden(System.Windows.UIElement element)
        {
            return (bool)element.GetValue(IsTabHiddenProperty);
        }

        public static void SetIsHiddenTabs(System.Windows.UIElement element, bool value)
        {
            element.SetValue(IsHiddenTabsProperty, value);
        }

        public static bool GetIsHiddenTabs(System.Windows.UIElement element)
        {
            return (bool)element.GetValue(IsHiddenTabsProperty);
        }

        public static void BindProperty(System.Windows.FrameworkElement source,
            System.Windows.DependencyProperty sourceProperty,
            System.Windows.FrameworkElement target,
            System.Windows.DependencyProperty targetProperty)
        {
            System.Windows.Data.Binding bind = new System.Windows.Data.Binding();
            bind.Source = source;
            bind.Path = new System.Windows.PropertyPath(sourceProperty);
            target.SetBinding(targetProperty, bind);
        }
    }
}
